#!BuildIgnore: post-build-checks
%if 0%{?suse_version}
%define daemon_group www
%define apache_service apache2
%define htmlroot /srv/www/htdocs
%define httpconfdir etc/apache2/conf.d
%else
%define daemon_group apache
%define apache_service httpd
%define htmlroot /var/www/html
%define httpconfdir etc/httpd/conf.d
%endif

Summary: op5config is a Web GUI interface for configuring a op5 Appliance system
Name: op5config
Version: 2.3.0
Release: op5.1
Group: op5/system-addons
License: op5 Software License
Prefix: /opt/op5sys
Source0: %name-%version.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}
Requires: bash, perl, perl-Expect, git-core >= 1.5.3.8
Requires: op5-httpd
Requires: portal
%if 0%{?suse_version}
# SLES-specific stuff
Requires: php53
Requires: php53-mbstring
Requires: php53-sockets
Requires: php53-pcntl
Requires: php53-posix
Requires: php53-iconv
%else
# Common RHEL stuff
Requires: php
Requires: php-mbstring
Requires: system-config-network-tui
%if 0%{?rhel} >= 6
# RHEL6-specific stuff
Requires: php-process
%else
# RHEL5-specific stuff
%endif
%endif

%package test
Summary: Test files for op5config
Group: op5/monitor
Requires: op5config = %version
Requires: rubygem-cucumber
Requires: rubygem-capybara
Requires: rubygem-poltergeist
Requires: rubygem-rspec
Requires: phantomjs


%description
Configuration interface for op5 Appliance

This enables easy configuration of an op5 Appliance system using
a userfriendly web gui.

%description test
Test files for op5config

%prep
%setup -q
# change default location of html files for SUSE in all files
%if 0%{?suse_version}
find -type f -exec %{__sed} '{}' -i -e 's#var/www/html#srv/www/htdocs#g'  \;
%endif

%install
rm -rf %buildroot
mkdir -p %buildroot
mkdir -p %buildroot/opt/op5config
mkdir -p %buildroot/opt/op5sys/bin
mkdir -p %buildroot/opt/op5sys/etc
mkdir -p %buildroot/opt/op5sys/lib/conf
mkdir -p %buildroot/opt/op5sys/lib/php
mkdir -p %buildroot/opt/op5sys/lib/perl/Config/INI
mkdir -p %buildroot/%htmlroot/op5config
mkdir -p %buildroot/%{_sysconfdir}/init.d
mkdir -p %buildroot/%{_sysconfdir}/cron.hourly
mkdir -p %buildroot/%httpconfdir
mkdir -p %buildroot/%{_sysconfdir}/modprobe.d

echo  "" > %buildroot/%{_sysconfdir}/modprobe.d/bonding.conf

install -m 644 lib/perl/Config/INI/Simple.pm %buildroot/opt/op5sys/lib/perl/Config/INI

install -m 644 lib/php/op5settings.php %buildroot/opt/op5sys/lib/php/

cp -r lib/* %buildroot/opt/op5sys/lib/conf
chmod -R 755 %buildroot/opt/op5sys/lib/conf

install -m 755 op5updates %buildroot/%{_sysconfdir}/cron.hourly

install -m 755 daemon/op5config %buildroot/%{_sysconfdir}/init.d
install -m 640 daemon/daemon.inc.php %buildroot/opt/op5sys/bin
install -m 640 daemon/protocol.inc.php %buildroot/opt/op5sys/bin
install -m 640 daemon/config-daemon.php %buildroot/opt/op5sys/bin
install -m 640 daemon/socket-daemon.inc.php %buildroot/opt/op5sys/bin
install -m 640 daemon/config-daemon.conf %buildroot/opt/op5sys/%{_sysconfdir}
install -m 640 bugfix.tar %buildroot/opt/op5sys/%{_sysconfdir}
install -m 640 daemon/sockets.inc.php %buildroot/opt/op5sys/bin
install -m 640 daemon/logger.inc.php %buildroot/opt/op5sys/bin
install -m 640 factory_settings.tar %buildroot/opt/op5sys/%{_sysconfdir}/factory_settings.tar

install -m 644 op5config-http.conf %buildroot/%httpconfdir
cp -r gui/{css,images,js,index.php,.htaccess} %buildroot%htmlroot/op5config
cp -r gui/{application,system} %buildroot/opt/op5config
mkdir %buildroot/opt/op5config/application/{logs,cache}
chmod 775 %buildroot/opt/op5config/application/{logs,cache}
mkdir %buildroot%htmlroot/backups

cp -r test %buildroot/%prefix
cp -r config %buildroot/%prefix/test

%files
%defattr(-, root, root)
/opt/op5sys/lib/conf/*
/opt/op5sys/bin/*
/%{_sysconfdir}/init.d/op5config
/%{_sysconfdir}/cron.hourly/op5updates
/opt/op5sys/lib/perl/Config/INI/Simple.pm
/opt/op5sys/lib/php/op5settings.php
/opt/op5sys/etc/config-daemon.conf
/opt/op5sys/etc/bugfix.tar
/opt/op5sys/etc/factory_settings.tar
/%httpconfdir/op5config-http.conf
/%{_sysconfdir}/modprobe.d/bonding.conf
%defattr(-, root, %daemon_group)
/opt/op5config/*
%htmlroot/op5config/
%attr(775, root, %daemon_group) /opt/op5config/application/logs
%attr(775, root, %daemon_group) /opt/op5config/application/cache
%attr(775, root, %daemon_group) %htmlroot/backups
%exclude %prefix/test

%files test
%defattr(664,root,%daemon_group,755)
%prefix/test

%clean
rm -rf %buildroot

%pre
if [ -e "/%{_sysconfdir}/init.d/op5config" ]; then
	/%{_sysconfdir}/init.d/op5config stop
fi
# and to be sure
CONFIG_PID=`ps ax | grep config-daemon | grep -v grep  | cut -d " " -f 1`
# We got a PID and it's numeric (confirmed by -eq)
if [ "$CONFIG_PID" -ge '0' ] &> /dev/null; then
	kill $CONFIG_PID
fi

%post
%if ! 0%{?suse_version}
	# $1 equals 1 on clean install (2 (or higher) on upgrade)
	if [ $1 -eq 1 ]; then
		/opt/op5sys/lib/conf/centos/sys/repo init || echo "Problems creating the configure repository. Please, create it manually"
		/sbin/chkconfig --add op5config || echo "Problems adding op5config to startup"
	elif [ $1 -gt 1 ]; then
		if [ ! -e /%{_sysconfdir}/sysconfig/network-scripts/ifup ]; then
			tar xf /opt/op5sys/%{_sysconfdir}/bugfix.tar -C /
			cp /%{_sysconfdir}/hosts /%{_sysconfdir}/sysconfig/networking/profiles/default/hosts
			cp /%{_sysconfdir}/sysconfig/network /%{_sysconfdir}/sysconfig/networking/profiles/default/network
			cp /%{_sysconfdir}/resolv.conf /%{_sysconfdir}/sysconfig/networking/profiles/default/resolv.conf
			interfaces="$(ifconfig | grep eth | cut -d ' ' -f 1)"
			for i in $interfaces; do
				/opt/op5sys/lib/conf/centos/network/edit iface-manual $i $i 0.0.0.0 0.0.0.0 0.0.0.0
			done
			touch /opt/op5sys/etc/warning
			echo "*******************************************************************"
			echo " The system has detected that your network configuration is broken"
			echo " Please check the settings before rebooting"
			echo "*******************************************************************"
		fi
		/opt/op5sys/lib/conf/centos/sys/repo reinit || echo "Problems rebuilding the configure repository. Please, rebuild it manually"
	fi
%else
	if [ $1 -eq 1 ]; then
		/sbin/chkconfig --add op5config || echo "Problems adding op5config to startup"
	fi
%endif

if [ -e "/%{_sysconfdir}/init.d/op5config" ]; then
	/%{_sysconfdir}/init.d/op5config start
fi

%preun
%if ! 0%{?suse_version}
	# $1 equals 0 on uninstall
	if [ $1 -eq 0 ]; then
		/sbin/chkconfig --del op5config || echo "Problems removing op5config to startup"
		/opt/op5sys/lib/conf/centos/sys/repo uninit || echo "Problems deleting the configure repository. Please, delete it manually"
	fi
%else
	if [ $1 -eq 0 ]; then
		/sbin/chkconfig --del op5config || echo "Problems removing op5config to startup"
	fi
%endif
